<template>
  <div class="gpa-diff-entry" :class="componentCSS">
    <div class="-text--center">
      <rui-toolbar class="-mtd">
        <rui-button @click="ignored = true">{{ $t('js.admin.import.ignore') }}</rui-button>

        <rui-button v-if="current && currentBaseUrl" :href="`${currentBaseUrl}/${current.library_id}`" target="_blank">
          {{ $t('js.admin.import.open_existing') }}
        </rui-button>

        <rui-button variant="creative" :disabled="!canSync || loading" end-icon="caret-double-right" @click="sync">
          {{ current ? $t('js.admin.import.update') : $t('js.admin.import.import') }}
        </rui-button>
      </rui-toolbar>
    </div>

    <rui-errors :errors="errors" :has-title="false" />

    <gpa-diff-line v-for="field in fieldsToCompare"
                   :key="field"
                   :field="field"
                   :trusted="trusted[field]"
                   :current="current && current[field]"
                   :disabled="loading || !current || !canSync"
                   :message="requirementsMessages[field]"
                   @sync="syncField(field)" />
  </div>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiErrors from '@experiments-labs/rise_ui/src/components/DataDisplay/Error/Errors.vue'
import RuiToolbar from '@experiments-labs/rise_ui/src/components/Toolbar/Toolbar.vue'
import GpaDiffLine from './DiffLine.vue'

import TrustedFamily from '../../../../classes/models/trustedData/TrustedFamily'
import TrustedGenus from '../../../../classes/models/trustedData/TrustedGenus'
import TrustedResource from '../../../../classes/models/trustedData/TrustedResource'
import TrustedResourceInteractionsGroup from '../../../../classes/models/trustedData/TrustedResourceInteractionsGroup'
import TrustedResourceInteraction from '../../../../classes/models/trustedData/TrustedResourceInteraction'

export default {
  name: 'GpaDiff',
  components: { RuiErrors, RuiButton, RuiToolbar, GpaDiffLine },
  props: {
    trusted: { required: true, type: [TrustedFamily, TrustedGenus, TrustedResource, TrustedResourceInteractionsGroup, TrustedResourceInteraction] },
    current: { required: false, type: Object, default: null },
    trustedClass: { required: true, type: Function },
    currentBaseUrl: { required: false, type: String, default: null },
  },
  data () {
    return {
      errors: null,
      loading: false,
      ignored: false,
      fieldsToCompare: this.trustedClass.fieldsToCompare,
    }
  },
  computed: {
    requirementsMessages () {
      const hash = {}
      const references = this.trusted.referencesValues()
      this.trusted.constructor.requiredReferences.forEach((r) => {
        // Not required if trusted is unset
        if (!references[r]) return

        hash[r] = null
        if (!references[r].current) hash[r] = this.$t('js.admin.import.missing_reference')
      })

      return hash
    },
    canSync () {
      for (const f of Object.keys(this.requirementsMessages)) {
        if (this.requirementsMessages[f]) return false
      }

      return true
    },
    componentCSS () {
      return [
        this.ignored && '-hidden',
      ]
    },
  },

  methods: {
    syncField (field) {
      this.save(field)
    },
    sync () {
      this.save()
    },
    save (field = null) {
      this.loading = true
      this.errors = null

      this.trusted.updateCurrent(this.current, field)
        .catch((errors) => { this.errors = errors })
        .then(() => { this.loading = false })
    },
  },
}
</script>

<style lang="scss" src="./Diff.scss" />
